package com.qmth.boot.test.core.fss;

import com.qmth.boot.core.fss.store.impl.OssStore;
import com.qmth.boot.tools.models.ByteArray;
import org.apache.commons.lang3.RandomStringUtils;
import org.junit.Assert;
import org.junit.Test;

import java.io.ByteArrayInputStream;
import java.time.Duration;

public class OssStoreTest {

    private String server_cloud = "https://qmth-test.oss-cn-shenzhen.aliyuncs.com";

    private String server_local = "http://oss-file.qmth.com.cn/test";

    private String config_cloud = "oss://LTAI4FnJ2pgV6aGceYcCkeEi:ktrMEVE7PfoxRPeJUPDFeygOIH4aU7@qmth-test.oss-cn-shenzhen.aliyuncs.com";

    private String config_local = "oss://key:secret@test.oss-api.qmth.com.cn";

    @Test
    public void test() throws Exception {
        OssStore store = new OssStore(server_local, config_local);
        String content = RandomStringUtils.random(128, true, true);
        ByteArray data = ByteArray.fromString(content);
        store.write("/test/1.txt", new ByteArrayInputStream(data.value()), ByteArray.md5(data.value()).toHexString());
        //Assert.assertTrue(store.exist("test/1.txt"));
        Assert.assertEquals(content, ByteArray.fromInputStream(store.read("test/1.txt")).toString());
        String url = store.getPresignedUrl("/test/1.txt", Duration.ofMinutes(5));
        //System.out.println(url);
        Assert.assertTrue(url.startsWith(store.getServer()));
        store.close();
    }

}
