package com.qmth.boot.core.metrics.service;

import com.qmth.boot.core.metrics.model.MetricsResult;

import java.util.List;

/**
 * 统计服务接口
 */
public interface MetricsService {

    /**
     * 记录单次统计结果
     *
     * @param endpoint
     * @param status
     * @param timecost
     */
    void record(String endpoint, int status, long timecost);

    /**
     * 获取某个统计点的统计结果
     *
     * @param endpoint
     * @return
     */
    MetricsResult result(String endpoint);

    /**
     * 获取所有统计点的统计结果
     *
     * @return
     */
    List<MetricsResult> result();

    /**
     * 重置某个统计点的统计结果
     *
     * @param endpoint
     */
    void reset(String endpoint);

    /**
     * 重置所有统计结果
     */
    void reset();
}
