package com.qmth.boot.core.rateLimit.service.impl;

import java.util.concurrent.atomic.AtomicInteger;

/**
 * 内存限流控制单元
 */
public class RateLimitor {

    private long time;

    private AtomicInteger count;

    public RateLimitor(long time) {
        this.time = time;
        this.count = new AtomicInteger(0);
    }

    public synchronized void reset(long time) {
        if (time != this.time) {
            this.time = time;
            this.count.set(0);
        }
    }

    public int incr() {
        return this.count.incrementAndGet();
    }

    public long time() {
        return time;
    }

    public int count() {
        return count.get();
    }

}
